#!/usr/bin/perl
#This generates the index.html for the repository

use strict;
use DBI;

#change these variables to the date you want the download counter to begin
my $datestamp_year = 2010;
my $datestamp_month = 7;
my $datestamp_day = 1;
##########################################################################

my %yearhash = (1 => "January",
		2 => "February",
		3 => "March",
		4 => "April",
		5 => "May",
		6 => "June",
		7 => "July",
		8 => "August",
		9 => "September",
		10 => "October",
		11 => "November",
		12 => "December", );

my $potd;
my $creator = "";
my $fn;
my $ln;
my $archive_count;
my $seed;
my $id;
my $downloads;
#create seed for picking random item ##########
{
        use integer;
        $seed = time()/86400;
}
################################################


#get a count of items ######################
my $dsn = 'DBI:mysql:test1:localhost';
my $dbh = DBI->connect($dsn, 'root', 'pass');
my $sth = $dbh->prepare(qq{
    select count(*) from eprint 
        where eprint_status = 'archive'
});
$sth->execute();
$archive_count = $sth->fetchrow_array();
############################################


#pick a random item#########################
$sth = $dbh->prepare(qq{
	select title, eprintid from eprint
		where eprint_status = 'archive' order by rand($seed) limit 1
});
$sth->execute();
($potd, $id) = $sth->fetchrow_array();
#############################################


#find the author############################
$sth = $dbh->prepare(qq{
	select creators_name_given, creators_name_family from eprint_creators_name
		where eprintid = $id
});
$sth->execute();
while(($fn, $ln) = $sth->fetchrow_array())
{
	my $fn_nospaces = $fn;
	my $ln_nospaces = $ln;
	$fn_nospaces =~ s/ /_/gi;
	$ln_nospaces =~ s/ /_/gi;
	$ln_nospaces =~ s/\./=2E/gi;
	$fn_nospaces =~ s/\./=2E/gi;

	if($creator ne "")
	{
		$creator = "$creator, <a href=\"view/author/$ln_nospaces,_$fn_nospaces.html\">$fn $ln</a>";
	}
	else
	{
		$creator = "<a href=\"view/author/$ln_nospaces,_$fn_nospaces.html\">$fn $ln</a>";
	}
}
###############################################

#get the number of downloads ##################
$sth = $dbh->prepare(qq{
	select count(*) from access where service_type_id = "?fulltext=yes" AND requester_user_agent NOT LIKE "%GoogleBot%" AND requester_user_agent NOT LIKE "%Yahoo%" AND requester_user_agent NOT LIKE "%msnbot%" AND requester_user_agent NOT LIKE "%Ultraseek%" AND requester_user_agent NOT LIKE "%Yandex%" AND requester_user_agent NOT LIKE "%Celestial%" AND requester_user_agent NOT LIKE "%FAST Enterprise Crawler%" AND requester_user_agent NOT LIKE "%FDM%" AND requester_user_agent NOT LIKE "%Ask Jeeves/Teoma%" AND requester_user_agent NOT LIKE "%Daumoa%" AND requester_user_agent NOT LIKE "%Microsoft Office Protocol Discovery%" AND requester_user_agent NOT LIKE "%Microsoft Data Access Internet Publishing Provider Protocol Discovery%" AND requester_user_agent NOT LIKE "%Microsoft Office Existence Discovery%" AND requester_user_agent NOT LIKE "%User-Agent%" AND requester_user_agent NOT LIKE "%Sogou%" AND requester_user_agent NOT LIKE "%OAPS Document Fetcher%" AND requester_user_agent NOT LIKE "%facebookexternalhit%" AND requester_user_agent NOT LIKE "%iCopyright Conductor%" AND requester_user_agent NOT LIKE "%ia_archiver%" AND requester_user_agent NOT LIKE "%Baidu%" AND requester_user_agent NOT LIKE "%bot%" AND ((datestamp_year = $datestamp_year AND datestamp_month >= $datestamp_month) OR datestamp_year > $datestamp_year);
});
$sth->execute();
$downloads = $sth->fetchrow_array();
###############################################

#done with sql
$sth->finish();
$dbh->disconnect();

#write the index.html
open(FILE, ">/opt/eprints3/archives/test1/html/en/index.html");
print FILE <<ENDHTML;
Your index.html code here...
ENDHTML
close FILE;

